package com.idea.customerManagement.dto;

import com.idea.customerManagement.model.RoomSelectionInfo;
import io.swagger.annotations.ApiModel;
import lombok.Data;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;
import java.util.List;

@Data
public class RoomSelectionInfoDto extends RoomSelectionInfo {

    /**
     * 单元/楼栋号
     */
    private String buildName;

    /**
     * 户室号
     */
    private String roomNo;

    /**
     * 套内面积（㎡)
     */
    private Double actualInternalArea;

    /**
     * 建筑面积（㎡)
     */
    private Double actualBuildArea;

    /**
     * 装修情况
     */
    private Double decorationSituation;

    private String createdName;

    private String buyerName;

    private String groupDiscName;

    private String pkInformerId;

    private String discIds;

    private List<String> discIdList;

    private String roomSelectionDate;

}