package com.idea.paymentManagement.model;

import lombok.Data;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

@Data
public class RefundDetail implements Serializable {
    private String id;

    private String refundManageId;

    private String type;

    private Integer contentType;

    private BigDecimal receivedAmount;

    private BigDecimal deductible;

    private BigDecimal actualRefundAmount;

    private String createdId;

    private Date createdAt;

    private Date updatedAt;

    private String updatedId;

    private Integer ncSubmitStatus;

    private Date ncSubmitDate;

    private String ncSubmitName;

    private Integer isHide;

    private String ncJson;

    private static final long serialVersionUID = 1L;

}