package com.idea.buildManage.excel;

import com.alibaba.excel.annotation.ExcelIgnore;
import com.alibaba.excel.annotation.ExcelProperty;
import lombok.Data;

@Data
public class MnpBuildingExcel {

    @ExcelProperty(value = "楼盘/小区名称")
    private String groupName;

    @ExcelProperty(value = "分期名称")
    private String discName;

    @ExcelProperty(value = "单元/楼栋号")
    private String buildNum;

    @ExcelProperty(value = "施工号")
    private String constructionNum;

    @ExcelProperty(value = "总面积（㎡）")
    private String area;

    @ExcelProperty(value = "住宅面积（㎡）")
    private String residentialArea;

    @ExcelProperty(value = "非住宅面积（㎡）")
    private String unResidentialArea;

    @ExcelProperty(value = "占地面积（㎡）")
    private String coverAnArea;

    @ExcelProperty(value = "地下面积（㎡）")
    private String undergroundArea;

    @ExcelProperty(value = "房号")
    private String roomNum;

    @ExcelProperty(value = "套数")
    private String numberInfo;

    @ExcelProperty(value = "总层数")
    private String floors;

    @ExcelProperty(value = "地上层数")
    private String overgroundFloors;

    @ExcelProperty(value = "地下层数")
    private String undergroundFloors;

    @ExcelProperty(value = "结构")
    private String structure;

    @ExcelProperty(value = "行政区划")
    private String regionalismCode;

    @ExcelProperty(value = "地号")
    private String landCode;

    @ExcelProperty(value = "备注")
    private String remark;

    @ExcelProperty(value = "标准价格参考层及差价系数备注说明")
    private String priceRemark;

    @ExcelIgnore
    private String reason;


}
