package com.idea.paymentManagement.dto;

import com.idea.paymentManagement.model.PayLog;
import lombok.Data;

import java.math.BigDecimal;

@Data
public class PayLogDto extends PayLog {

    private String contractNumber;

    private String buyerName;

    private String houseName;

    private String paymentMethodStr;

    private String deadLine;

    /**
     * 应收金额
     */
    private BigDecimal receivableMoney;

    /**
     * 已收金额
     */
    private BigDecimal receivedMoney;

    /**
     * 欠款金额
     */
    private BigDecimal arrears;

    private String createdName;

    private String pkInformerId;

}
